package com.dqqdo.mouse;

import java.util.LinkedList;
import java.util.List;

import android.app.Activity;
import android.app.Application;
import android.content.Intent;
import android.os.Handler;

import com.dqqdo.mouse.services.CastListenService;

public class MouseApplication extends Application {

	// 检测自身是否可以更新的url地址
	// 储存 activity 句柄的集合
	private List<Activity> mList = new LinkedList<Activity>();
	// pc的ip地址
	private String strPcIpString = "";

	private Handler socketHandler = null;

	public Handler getSocketHandler() {
		return socketHandler;
	}

	public void updateHandler(Handler handler) {
		this.socketHandler = handler;
	}

	/**
	 * 添加新的activity至集合
	 * 
	 * @param activity
	 */
	public void addActivity(Activity activity) {
		mList.add(activity);
	}

	public void removeActivity(Activity activity) {
		mList.remove(activity);
	}

	@Override
	public void onCreate() {
		// 每次应用开启时自动登录
		super.onCreate();

		// 开启定时检测服务
		startService(new Intent(this, CastListenService.class));
		
	}

	/**
	 * 退出整个应用程序
	 */
	public void exitApp() {
		// 加一个逻辑判断，如果activity堆栈为null，则退出应用程序
		if (mList != null) {
			// 退出时，依次关闭所有的activity
			try {
				for (Activity activity : mList) {
					if (activity != null) {
						activity.finish();
					}
				}
			} catch (Exception e) {
				// e.printStackTrace();
			} finally {
				// 退出虚拟机
			}
		}

		System.exit(0);

	}

	public String getStrPcIpString() {
		return strPcIpString;
	}

	public void setStrPcIpString(String strPcIpString) {
		this.strPcIpString = strPcIpString;
	}

}
