package com.dqqdo.mouse.net;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.InetAddress;
import java.net.MulticastSocket;
import java.net.SocketException;
import java.net.UnknownHostException;

import android.content.Context;
import android.net.wifi.WifiManager;
import android.os.Handler;
import android.util.Log;

import com.dqqdo.mouse.MouseApplication;
import com.dqqdo.mouse.utils.NetUtils;

public class MulticastClient implements Runnable {

	private MulticastSocket mMultiSocket;
	private InetAddress mAddress;
	private boolean mScan = false;
	private Thread mThread = null;
	private byte[] mBuffer = new byte[256];
	private DatagramPacket mDatagram = null;

	private static final String TAG = "dqq";
	private Context mContext = null;
	public static final String BROADCAST_IP = "238.5.6.7";
	public static final int CLIENT_RECEIVE_PORT = 23336;

	private MouseApplication app;
	private Handler mHandler;
	WifiManager.MulticastLock mLock;
	WifiManager manager;

	public MulticastClient(Context context, Handler handler) throws IOException {
		mContext = context;
		this.mHandler = handler;

		app = (MouseApplication) context.getApplicationContext();
		manager = (WifiManager) app.getSystemService(Context.WIFI_SERVICE);
		Log.d(TAG, "######## MulticastClient #########");
		mAddress = InetAddress.getByName(BROADCAST_IP);
		mMultiSocket = new MulticastSocket(CLIENT_RECEIVE_PORT);

		Log.d(TAG, "MulticastClient");

		mThread = new Thread(this);

	}

	public void startReceive() {
		this.mScan = true;
		mThread.start();
	}

	public void stopReceive() {
		this.mScan = false;
	}

	@Override
	public void run() {
		// TODO Auto-generated method stub
		Log.d(TAG, "run");
		// 初始化多点接受
		try {
			String ip = NetUtils.getIp();
//			if (ip != null) {
//				Log.d("dqq", "ip  ===  " + ip);
//				mMultiSocket.setNetworkInterface(NetworkInterface
//						.getByInetAddress(InetAddress.getByName(ip)));
//			}
			
			mMultiSocket.joinGroup(mAddress);
		} catch (SocketException | UnknownHostException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		scan_recv();
	}

	private String receiveStr = "";

	public void scan_recv() {

		mLock = manager.createMulticastLock("udpwifi");
		
		// DatagramPacket packet;
		while (mScan) {
			Log.d(TAG, "mScan  == " + mScan);
			mLock.acquire();
			try {
				mDatagram = new DatagramPacket(mBuffer, mBuffer.length);
				mMultiSocket.receive(mDatagram);
				receiveStr = new String(mDatagram.getData());
				receiveStr = receiveStr.trim();
				Log.d(TAG, "receiveStr  ===  " + receiveStr);
				if (receiveStr != null) {
					if (receiveStr.startsWith("dqq:")) {
						String strPcIp = receiveStr.substring(receiveStr
								.indexOf(':') + 1);
						Log.d(TAG, "strPcIp  ===  " + strPcIp);
						app.setStrPcIpString(strPcIp);
						// this.mScan = false;
						mHandler.sendEmptyMessage(TOAST_MSG_RECEIVE);
					}
				}
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				Log.d("dqq", "" + e.getMessage());
				this.mScan = false;
			}

			Log.d("dqq", "run 00000");
			try {
				Log.d(TAG, "sleep");
				Thread.sleep(100);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				Log.d("dqq", "run 00000" + e.getMessage());
			}
			Log.d("dqq", "run 00000");

			mLock.release();
		}

	}

	private final int TOAST_MSG_RECEIVE = 0x01;

}