package com.dqqdo.mouse.net;

import java.io.IOException;
import java.io.OutputStream;
import java.net.Socket;
import java.net.UnknownHostException;

import android.content.Context;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.util.Log;

import com.dqqdo.mouse.MouseApplication;

public class TcpClientThread extends Thread {

	private final int SERVER_PORT = 23337;
	Socket client;

	MouseApplication app;
	private Handler mHandler;

	public TcpClientThread(Context context) {
		app = (MouseApplication) context.getApplicationContext();
	}

	public void send(String data) throws IOException {
		// 建立连接后就可以往服务端写数据了
		Log.d("dqq", "data  ====  " + data);
		data = data + "\n";
		OutputStream os = client.getOutputStream();
		os.write(data.getBytes());
		os.flush();
	}

	public void closeSocket() throws IOException {
		client.close();
	}

	private boolean connectSocket(String ip) {
		// 要连接的服务端IP地址
		String host = ip;
		// 与服务端建立连接
		try {
			client = new Socket(host, SERVER_PORT);
			client.setKeepAlive(true);
		} catch (UnknownHostException e) {
			e.printStackTrace();
			return false;
		} catch (IOException e) {
			e.printStackTrace();
			return false;
		}

		return true;
	}

	@Override
	public void run() {

		// 建立消息循环的步骤
		Looper.prepare();// 1、初始化Looper
		mHandler = new Handler() {// 2、绑定handler到CustomThread实例的Looper对象
			@Override
			public void handleMessage(Message msg) {// 3、定义处理消息的方法
				switch (msg.what) {
				case 0x109:
					String data = msg.getData().getString("msg");
					// Log.d("dqq", "data  ===  " + data);
					try {
						send(data);
					} catch (IOException e) {
						e.printStackTrace();
					}

					break;
				}
			}
		};

		app.updateHandler(mHandler);
		boolean result = connectSocket(app.getStrPcIpString());
		Log.d("dqq", "result  ====  " + result);
		Looper.loop();// 4、启动消息循环

	}

}
