package com.dqqdo.mouse.ui;

import yahn.com.Rbgf;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.widget.EditText;
import android.widget.LinearLayout;

import com.dqqdo.mouse.MouseApplication;
import com.dqqdo.mouse.R;
import com.dqqdo.mouse.beans.MouseMessageBean;
import com.dqqdo.mouse.net.TcpClientThread;

public class MainActivity extends Activity {

	private LinearLayout llMouseMove;
	private LinearLayout llMouseLeft;
	private LinearLayout llMouseRight;
	private MouseApplication app;
	private Handler socketHandler = null;
	TcpClientThread tcpClientThread;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		uiInit();
		this.app = (MouseApplication) this.getApplicationContext();

		
		final EditText etIpStr;
		new AlertDialog.Builder(this).setTitle("请输入")
				.setIcon(android.R.drawable.ic_dialog_info)
				.setView(etIpStr = new EditText(this))
				.setPositiveButton("确定", new DialogInterface.OnClickListener() {

					@Override
					public void onClick(DialogInterface dialog, int which) {

						app.setStrPcIpString(etIpStr.getEditableText()
								.toString());
						Log.d("dqq", "" + app.getStrPcIpString());

						tcpClientThread = new TcpClientThread(MainActivity.this);
						tcpClientThread.start();
					}
				}).show();

	}

	float preX, preY;
	float nowX, nowY;

	MouseMessageBean bean;
	int count = 0;
	long firClick = 0, secClick;

	private void uiInit() {

		llMouseMove = (LinearLayout) findViewById(R.id.ll_mouse_move);
		llMouseMove.setOnTouchListener(new View.OnTouchListener() {

			@Override
			public boolean onTouch(View v, MotionEvent event) {

				nowX = event.getX();
				nowY = event.getY();

				if (socketHandler == null) {
					socketHandler = app.getSocketHandler();
				}

				int action = event.getAction();
				switch (action) {
				case MotionEvent.ACTION_MOVE:
					float disX = nowX - preX;
					float disY = nowY - preY;

					bean = new MouseMessageBean(disX, disY, false, false,
							isLeftLongClick);

					Message msg = new Message();
					Bundle bundle = new Bundle();
					bundle.putString("msg", bean.toString());
					msg.setData(bundle);
					msg.what = 0x109;
					if (socketHandler != null) {
						socketHandler.sendMessage(msg);
					} else {
						Log.d("dqq", "socketHandler  ===  null---");
					}

					preX = nowX;
					preY = nowY;
					break;

				case MotionEvent.ACTION_DOWN:

					count++;
					if (count == 1) {
						firClick = System.currentTimeMillis();
					} else if (count == 2) {
						secClick = System.currentTimeMillis();
						if (secClick - firClick < 1000) {
							// 双击事件
							disX = nowX - preX;
							disY = nowY - preY;
							bean = new MouseMessageBean(disX, disY, true,
									false, false);

							msg = new Message();
							bundle = new Bundle();
							bundle.putString("msg", bean.toString());
							msg.setData(bundle);
							msg.what = 0x109;
							if (socketHandler != null) {
								socketHandler.sendMessage(msg);
							}
						}
						count = 0;
						firClick = 0;
						secClick = 0;
					}

					preX = nowX;
					preY = nowY;

					break;
				default:

					preX = nowX;
					preY = nowY;
					break;
				}

				return true;
			}
		});

		llMouseLeft = (LinearLayout) findViewById(R.id.ll_mouse_left);
		llMouseLeft.setOnClickListener(new View.OnClickListener() {

			@Override
			public void onClick(View v) {

				float disX = nowX - preX;
				float disY = nowY - preY;
				bean = new MouseMessageBean(disX, disY, true, false, false);

				Message msg = new Message();
				Bundle bundle = new Bundle();
				bundle.putString("msg", bean.toString());
				msg.setData(bundle);
				msg.what = 0x109;
				if (socketHandler != null) {
					socketHandler.sendMessage(msg);
				}
			}
		});

		llMouseLeft.setOnTouchListener(new View.OnTouchListener() {

			@Override
			public boolean onTouch(View v, MotionEvent event) {

				int action = event.getAction();
				switch (action) {
				case MotionEvent.ACTION_DOWN:
					isLeftLongClick = true;
					break;
				case MotionEvent.ACTION_UP:
					isLeftLongClick = false;
					break;

				default:
					break;
				}

				return false;
			}
		});

		llMouseRight = (LinearLayout) findViewById(R.id.ll_mouse_right);
		llMouseRight.setOnClickListener(new View.OnClickListener() {

			@Override
			public void onClick(View v) {

				float disX = nowX - preX;
				float disY = nowY - preY;
				bean = new MouseMessageBean(disX, disY, false, true, false);

				Message msg = new Message();
				Bundle bundle = new Bundle();
				bundle.putString("msg", bean.toString());
				msg.setData(bundle);
				msg.what = 0x109;
				if (socketHandler != null) {
					socketHandler.sendMessage(msg);
				}
			}
		});
	}

	private boolean isLeftLongClick = false;

}
